/* BdfServer - Copyright (c) 2026 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package fr.exemole.bdfserver.json;

import java.io.IOException;
import net.fichotheque.exportation.table.ColDef;
import net.fichotheque.exportation.table.ColDefTitleProvider;
import net.mapeadores.util.json.CommonJson;
import net.mapeadores.util.json.JSONWriter;


/**
 *
 * @author Vincent Calame
 */
public final class ColDefJson {

    private ColDefJson() {

    }

    public static void properties(JSONWriter jw, ColDef colDef, ColDefTitleProvider colDefTitleProvider) throws IOException {
        String castType = colDef.getCastType();
        if (castType.isEmpty()) {
            castType = "string";
        }
        jw.key("name")
                .value(colDef.getColName());
        jw.key("title")
                .value(colDefTitleProvider.getTitle(colDef));
        jw.key("cast")
                .value(castType);
        jw.key("match")
                .value(colDef.getMatchingComponentName());
        jw.key("attributes");
        CommonJson.object(jw, colDef.getAttributes());
    }

}
